package snowBallPackage
{
	function Player::ActivateStuff (%obj)
	{
		Parent::ActivateStuff (%obj);

		// find precipitation
		%precipitation = 0;
		for(%i=0;%i<MissionGroup.getCount();%i++) {
			if(MissionGroup.getObject(%i).getClassName() $= "Precipitation" || MissionGroup.getObject(%i).getClassName() $= "PrecipitationRebuilt") {
				%precipitation = MissionGroup.getObject(%i);
				break;
			}
		}

		if (strstr (strlwr (%precipitation.dataBlock), "snow") == -1 && strstr (strlwr (%precipitation.dropTexture), "snow") == -1)
		{
			return;
		}
		if (%obj.activateLevel >= 2)
		{
			%type = $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType;
			%pos = %obj.getEyePoint ();
			%vec = VectorScale (%obj.getEyeVector (), 5);
			%end = VectorAdd (%pos, %vec);
			%brick = getWord (containerRayCast (%pos, %end, %type, %obj), 0);
			if (!isObject (%brick) || %brick.numEvents != 0)
			{
				return;
			}
			
			// brick
			if (%brick.getType () & $TypeMasks::FxBrickObjectType)
			{
				%color = %brick.getColorID ();
				%color = getColorIDTable (%color);
			}
			
			// v21 ground plane
			else if(%brick.getType () & $TypeMasks::FxPlaneObjectType)
			{
				%color = getWord (%brick.color, 0) / 255 SPC getWord (%brick.color, 1) / 255 SPC getWord (%brick.color, 2) / 255;
				if (%brick.topTexture !$= "Add-Ons/Ground_Plate/plate.png" && %brick.topTexture !$= "Add-Ons/Ground_White/white.png")
				{
					return;
				}
			}
			
			// terrain
			else if (%brick.getType () & $TypeMasks::TerrainObjectType)
				%color = "1 1 1 1";
			
			// Slate edits
			else if (%brick.getType () & $TypeMasks::InteriorObjectType) {
				if(strstr (strlwr (%brick.interiorFile), "slate") >= 0 || strstr (strlwr (%brick.interiorFile), "plate") >= 0) {
					if(isObject($AP_PlateColor))
						%color = $AP_PlateColor.specularColor;
					else if(isObject(Water))
						if(strstr (strlwr (Water.surfaceTexture), "snow") >= 0)
							%color = "1 1 1 1";
					else return;
				}
				else return;
			}
			else return;

			if (VectorDot (%color, "1 1 1") > 2.5 && !isObject (%obj.getMountedImage (0)))
			{
				%obj.mountImage (blankaBallImage, 0);
			}
		}
	}
	

};

activatePackage (snowBallPackage);
datablock AudioProfile (blankaBallExplosionSound)
{
	fileName = "./northImpact.wav";
	description = AudioClose3d;
	preload = 0;
};
datablock AudioProfile (blankaBallFireSound)
{
	fileName = "./northToss.wav";
	description = AudioClose3d;
	preload = 1;
};
datablock ParticleData (blankaBallTrailParticle)
{
	dragCoefficient = 3;
	windCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 300;
	lifetimeVarianceMS = 0;
	spinSpeed = 10;
	spinRandomMin = -50;
	spinRandomMax = 50;
	useInvAlpha = 1;
	animateTexture = 0;
	textureName = "base/data/particles/chunk";
	colors[0] = "1 1 1 0.3";
	colors[1] = "1 1 1 0.2";
	colors[2] = "1 1 1 0.0";
	sizes[0] = 0.3;
	sizes[1] = 0.12;
	sizes[2] = 0.05;
	times[0] = 0;
	times[1] = 0.5;
	times[2] = 1;
};
datablock ParticleEmitterData (blankaBallTrailEmitter)
{
	ejectionPeriodMS = 25;
	periodVarianceMS = 10;
	ejectionVelocity = 2;
	velocityVariance = 2;
	ejectionOffset = 0;
	phiReferenceVel = 0;
	phiVariance = 360;
	thetaMin = 0;
	thetaMax = 90;
	particles = blankaBallTrailParticle;
	useEmitterColors = 1;
};
datablock ParticleData (blankaBallExplosionParticle)
{
	dragCoefficient = 3;
	windCoefficient = 0;
	gravityCoefficient = 0.5;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 900;
	lifetimeVarianceMS = 300;
	spinSpeed = 10;
	spinRandomMin = -50;
	spinRandomMax = 50;
	useInvAlpha = 1;
	animateTexture = 0;
	textureName = "base/data/particles/cloud";
	colors[0] = "1 1 1 0.9";
	colors[1] = "1 1 1 0.0";
	sizes[0] = 1;
	sizes[1] = 2;
	times[0] = 0;
	times[1] = 1;
};
datablock ParticleEmitterData (blankaBallExplosionEmitter)
{
	ejectionPeriodMS = 7;
	periodVarianceMS = 0;
	lifetimeMS = 21;
	ejectionVelocity = 1;
	velocityVariance = 0;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = 0;
	particles = "blankaBallExplosionParticle";
	emitterNode = TenthEmitterNode;
};
datablock ParticleData (blankaBallExplosionParticle2)
{
	dragCoefficient = 0.1;
	windCoefficient = 0;
	gravityCoefficient = 0.5;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 1000;
	lifetimeVarianceMS = 500;
	spinSpeed = 10;
	spinRandomMin = -50;
	spinRandomMax = 50;
	useInvAlpha = 1;
	animateTexture = 0;
	textureName = "base/data/particles/chunk";
	colors[0] = "1 1 1 1.0";
	colors[1] = "1 1 1 0.0";
	sizes[0] = 0.5;
	sizes[1] = 0.5;
	times[0] = 0;
	times[1] = 1;
};
datablock ParticleEmitterData (blankaBallExplosionEmitter2)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	lifetimeMS = 7;
	ejectionVelocity = 2;
	velocityVariance = 0;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = 0;
	particles = "blankaBallExplosionParticle2";
	useEmitterColors = 1;
	emitterNode = HalfEmitterNode;
};
datablock ExplosionData (blankaBallExplosion)
{
	lifetimeMS = 150;
	soundProfile = "";
	emitter[0] = blankaBallExplosionEmitter;
	emitter[1] = blankaBallExplosionEmitter2;
	faceViewer = 1;
	explosionScale = "1 1 1";
	shakeCamera = 1;
	camShakeFreq = "0 0 0";
	camShakeAmp = "0 0 0";
	camShakeDuration = 0;
	camShakeRadius = 0;
	lightStartRadius = 0;
	lightEndRadius = 0;
	lightStartColor = "0.45 0.3 0.1";
	lightEndColor = "0 0 0";
	impulseRadius = 0;
	impulseForce = 2000;
	radiusDamage = 0;
	damageRadius = 0;
};
AddDamageType ("blankaBallDirect", '<bitmap:add-ons/Vehicle_Pirate_Cannon/ball> %1', '%2 <bitmap:add-ons/Vehicle_Pirate_Cannon/ball> %1', 1, 1);

if($Pref::Server::SnowballItem $= "")
	$Pref::Server::SnowballItem = true;

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Add snowball item", "Snowball", "$Pref::Server::SnowballItem", "bool", "Item_Snowball", true, 1, 0);
}

if($Pref::Server::SnowballItem) {
	datablock ItemData(blankaBallItem)
	{
		category  = "Weapon";
		className = "Weapon";

		shapeFile  = "./snowBall.dts";
		mass = 1;
		density = 0.2;
		elasticity = 0.2;
		friction = 0.6;
		emap = true;

		uiName = "Snowball ";
		iconName  = "./icon_Snowball";
		doColorShift = true;
		colorShiftColor = "1 1 1 1";

		image = blankaballImage;
		canDrop = true;
	};
}

datablock ProjectileData (blankaBallProjectile)
{
	uiName = "Snowball ";
	projectileShapeName = "./snowBall.dts";
	directDamage = 0;
	DirectDamageType = $DamageType::blankaBallDirect;
	impactImpulse = 0;
	verticalImpulse = 0;
	Explosion = blankaBallExplosion;
	particleEmitter = blankaBallTrailEmitter;
	brickExplosionRadius = 0;
	brickExplosionImpact = 1;
	brickExplosionForce = 40;
	brickExplosionMaxVolume = 24;
	brickExplosionMaxVolumeFloating = 24;
	muzzleVelocity = 30;
	velInheritFactor = 1;
	armingDelay = 0;
	lifetime = 20000;
	fadeDelay = 19500;
	bounceElasticity = 0;
	bounceFriction = 0;
	isBallistic = 1;
	gravityMod = 0.75;
	hasLight = 0;
	lightRadius = 3;
	lightColor = "0 0 0.5";
};
function blankaBallProjectile::onCollision (%this, %obj, %col, %fade, %pos, %normal)
{
	if (%col.getType () & $TypeMasks::PlayerObjectType)
	{
		%canDamage = miniGameCanDamage (%obj, %col);
		if (%canDamage == 1)
		{
			%col.setWhiteOut (0.5);
		}
		if (%canDamage == 1 && isEventPending (%col.tempColorSchedule))
		{
			%damage = %col.getDataBlock ().maxDamage * 2;
			%client = %col.client;
			%col.Damage (%obj, %pos, %damage, $DamageType::blankaBallDirect);
			%col.setDamageFlash (0);
			%col.setWhiteOut (1);
		}
		if (%canDamage)
		{
			%col.setTempColor ("1 1 1 1", 5000, %pos, %this);
		}
		ServerPlay3D (blankaBallExplosionSound, %col.getPosition ());
	}
	else 
	{
		ServerPlay3D (blankaBallExplosionSound, %pos);
	}
	if (isObject (getMiniGameFromObject (%obj)))
	{
		Parent::onCollision (%this, %obj, %col, %fade, %pos, %normal);
	}
}

datablock ShapeBaseImageData (blankaBallImage)
{
	shapeFile = "./Snowball.dts";
	emap = 1;
	mountPoint = 0;
	offset = "-0.03 0.05 0.03";
	correctMuzzleVector = 1;
	className = "WeaponImage";
	Item = blankaBallItem;
	ammo = " ";
	Projectile = blankaBallProjectile;
	projectileType = Projectile;
	melee = 0;
	armReady = 1;
	doColorShift = 1;
	colorShiftColor = "0.400 0.196 0 1.000";
	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.1;
	stateTransitionOnTimeout[0] = "Ready";
	stateSequence[0] = "ready";
	stateSound[0] = weaponSwitchSound;
	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Charge";
	stateAllowImageChange[1] = 1;
	stateName[2] = "Charge";
	stateTransitionOnTimeout[2] = "Armed";
	stateTimeoutValue[2] = 0.2;
	stateWaitForTimeout[2] = 0;
	stateTransitionOnTriggerUp[2] = "AbortCharge";
	stateScript[2] = "onCharge";
	stateAllowImageChange[2] = 0;
	stateName[3] = "AbortCharge";
	stateTransitionOnTimeout[3] = "Ready";
	stateTimeoutValue[3] = 0.3;
	stateWaitForTimeout[3] = 1;
	stateScript[3] = "onAbortCharge";
	stateAllowImageChange[3] = 0;
	stateName[4] = "Armed";
	stateTransitionOnTriggerUp[4] = "Fire";
	stateAllowImageChange[4] = 0;
	stateName[5] = "Fire";
	stateTransitionOnTimeout[5] = "Ready";
	stateTimeoutValue[5] = 0.5;
	stateFire[5] = 1;
	stateSequence[5] = "fire";
	stateScript[5] = "onFire";
	stateWaitForTimeout[5] = 1;
	stateAllowImageChange[5] = 0;
};
function blankaBallImage::onMount (%this, %obj, %slot)
{
	%obj.playThread (1, armReadyRight);
	if(isObject(blankaBallItem))
		if(%obj.tool[%obj.currTool] != %this.item.getID())
			%obj.playThread (3, activate2);
		else
			%obj.snowSlot = %obj.currTool;
}

function blankaBallImage::onUnMount (%this, %obj, %slot)
{
	%obj.playThread (2, root);
	if (%obj.snowThrown != 1 && %obj.snowSlot $= "" && %obj.tool[%obj.snowSlot] != %this.item.getID())
	{
		%p = new Projectile ("")
		{
			dataBlock = blankaBallProjectile;
			initialPosition = %obj.getMuzzlePoint (0);
			initialVelocity = VectorAdd (VectorScale (%obj.getMuzzleVector (0), 4), %obj.getVelocity ());
			sourceObject = %obj;
			client = %obj.client;
			sourceSlot = 0;
			originPoint = %obj.getMuzzlePoint (0);
			scale = %obj.getScale ();
			miniGame = %obj.client.miniGame;
		};
		MissionCleanup.add (%p);
		%obj.playThread (3, activate);
	}
	%obj.snowSlot = "";
}

function blankaBallImage::onCharge (%this, %obj, %slot)
{
	%obj.playThread (2, spearReady);
}

function blankaBallImage::onAbortCharge (%this, %obj, %slot)
{
	%obj.playThread (2, root);
}

function blankaBallImage::onFire (%this, %obj, %slot)
{
	%obj.playThread (2, spearThrow);
	ServerPlay3D (blankaBallFireSound, %obj.getPosition ());
	Parent::onFire (%this, %obj, %slot);

	%obj.snowThrown = 1;

	if(isObject(blankaBallItem))
		if(%obj.tool[%obj.snowSlot] == %this.item.getID()) {
			%obj.tool[%obj.snowSlot] = 0;
			%obj.weaponCount--;
			messageClient(%obj.client,'MsgItemPickup','',%obj.snowSlot,0);
			serverCmdUnUseTool(%obj.client);
		}

	%obj.unmountImage (0);
	%obj.snowThrown = 0;
	%obj.playThread (1, root);
}
